

function [jpeg_data] = get_jpeg_data(name)

    

    [y,cb,cr,Qy,Qcb,Qcr,c]=read_jpeg_data(name); %Read coefficients and quantization table
    
    %Transpose data and convert to double
    y=y'; y = double(y); Qy=Qy'; Qy=double(Qy);
    cb=cb'; cb = double(cb); Qcb=Qcb'; Qcb=double(Qcb);
    cr=cr'; cr = double(cr); Qcr=Qcr'; Qcr=double(Qcr);

    %Set component size
    [ny,my] = size(y);
    [ncb,mcb] = size(cb);
    [ncr,mcr] = size(cr);
    
    
    %Set new data matrices
    data = zeros(ny,my,3);
    ldata = zeros(ny,my,3);
    rdata = zeros(ny,my,3);
    d_index = logical(data);


    %Set and dequantize data
        %Set Y-data
        for i=1:8:ny
                for j=1:8:my
                    data(    i:i+7 , j:j+7 , 1 ) = y(    i:i+7 , j:j+7 ).*Qy;
                    d_index( i:i+7 , j:j+7 , 1 ) = true;
                    ldata(   i:i+7 , j:j+7 , 1 ) = data( i:i+7 , j:j+7 , 1 ) - 0.5*Qy;
                    rdata(   i:i+7 , j:j+7 , 1 ) = data( i:i+7 , j:j+7 , 1 ) + 0.5*Qy;
                    
                end
        end    
    
        %Set CB-data 
        for i=1:8:ncb
                for j=1:8:mcb
                    
                    data(    i:i+7 , j:j+7 , 2 ) = cb   ( i:i+7 , j:j+7 ).*Qcb;
                    d_index( i:i+7 , j:j+7 , 2 ) = true;
                    ldata(   i:i+7 , j:j+7 , 2 ) = data( i:i+7 , j:j+7 , 2 ) - 0.5*Qcb;
                    rdata(   i:i+7 , j:j+7 , 2 ) = data( i:i+7 , j:j+7 , 2 ) + 0.5*Qcb;
                   
                    
                end
        end
        %Set CR-data
        for i=1:8:ncr
                for j=1:8:mcr
                    
                    data(    i:i+7 , j:j+7 , 3 ) = cr   ( i:i+7 , j:j+7 ).*Qcr;
                    d_index( i:i+7 , j:j+7 , 3 ) = true;
                    ldata(   i:i+7 , j:j+7 , 3 ) = data( i:i+7 , j:j+7 , 3 ) - 0.5*Qcr;
                    rdata(   i:i+7 , j:j+7 , 3 ) = data( i:i+7 , j:j+7 , 3 ) + 0.5*Qcr;
                    
                end
        end
        
        %Save pointer for data projection
        cbdata = zeros(ncb,mcb);
        crdata = zeros(ncr,mcr);
        
        %Set result
        coeff_data = {data,cbdata,crdata,ldata,rdata,d_index};
        
        img_size = [ny,my;ncb,mcb;ncr,mcr];
        
        jpeg_data = {coeff_data,img_size};
        
end
    



