%Authors: 	Martin Holler and Kristian Bredies
%		University of Graz
%Contact	martin.holler@uni-graz.at

function [data,A] = jpeg_enc(u,rate)


[n,m] = size(u);
u = double(u);


%Set quantization matrix
A=[16 11 10 16 24 40 51 61;...
    12 12 14 19 26 58 60 55;...
    14 13 16 24 40 57 69 56;...
    14 17 22 29 51 87 80 62;...
    18 22 37 56 68 109 103 77;...
    24 35 55 64 81 104 113 92;...
    49 64 78 87 103 121 120 101;...
    72 92 95 98 112 100 103 99];
	
	%Set rate
	A = A.*rate;	
	A=min(A,255);
	
	%Allocate data
	data = zeros(n,m);
	
	
		%Encoding
		u = u - 128;
		for i=1:8:n
			for j=1:8:m
				data(i:i+7,j:j+7) = round( dct2( u(i:i+7,j:j+7) )./A  );				
			end
		end
		


end
