

function [u] = project_jpeg_data(u,jpeg_data)

%Get image size
img_size = jpeg_data{2};

ny =    img_size(1,1); my =  img_size(1,2);
ncb =   img_size(2,1); mcb = img_size(2,2);
ncr =   img_size(3,1); mcr = img_size(3,2);

%Get data pointer
coeff_data = jpeg_data{1};

data =      coeff_data{1};
cbdata =    coeff_data{2};
crdata =    coeff_data{3};
ldata =     coeff_data{4};
rdata =     coeff_data{5};
d_index =   coeff_data{6};


    %Downscale 
    cbdata = sdownscale(u(:,:,2),[ncb,mcb]);
    crdata = sdownscale(u(:,:,3),[ncr,mcr]);
        
        %Project to data
        %BDCT
        data(:,:,1) =           bdct(u(:,:,1),  8,'forward');
        data(1:ncb,1:mcb,2) =   bdct(cbdata,    8,'forward');
        data(1:ncr,1:mcr,3) =   bdct(crdata,    8,'forward');
        
        %Project
        data( d_index & ( data>rdata ) ) = rdata( d_index & ( data>rdata ) );
        data( d_index & ( data<ldata ) ) = ldata( d_index & ( data<ldata ) );
        
        %IBDCT + adding of unprojected image
        u(:,:,1)    =   bdct(data(:,:,1),           8,'inverse');
        cbdata      =   bdct(data(1:ncb,1:mcb,2),   8,'inverse') - cbdata;
        crdata      =   bdct(data(1:ncr,1:mcr,3),   8,'inverse') - crdata;
        
    %Add projection to original image
    u(:,:,2) = u(:,:,2) + supscale(cbdata,[ny,my]);
    u(:,:,3) = u(:,:,3) + supscale(crdata,[ny,my]);
    
    
end