%Function to calculate Frobenius-norm of a 3-vector of nxmx2 matrices
%Return value 2x3 vector with each component containing nxm matrix with norm of elements

function [v_norm] = vec_frob_norm_2(x)

if (size(x,4) == 3)
    norm = sqrt ( x(:,:,1,1).^2 + x(:,:,2,1).^2 + ...
                  x(:,:,1,2).^2 + x(:,:,2,2).^2 + ...
                  x(:,:,1,3).^2 + x(:,:,2,3).^2 );
    v_norm = cat(4,cat(3,norm,norm),cat(3,norm,norm),cat(3,norm,norm));
else
    norm = sqrt ( x(:,:,1).^2 + x(:,:,2).^2 );
    v_norm = cat(3,norm,norm);
end

end