%Function to calculate Frobenius-norm of a 3-vector of nxmx3 matrices
%Return value is a 3x3 vector with nxm matrix containing norm of elements
%in each component

function [v_norm] = vec_frob_norm_3(x)

if (size(x,4) == 3)
    norm = sqrt ( x(:,:,1,1).^2 + x(:,:,2,1).^2 + 2*(x(:,:,3,1).^2) + ...
                  x(:,:,1,2).^2 + x(:,:,2,2).^2 + 2*(x(:,:,3,2).^2) + ...
                  x(:,:,1,3).^2 + x(:,:,2,3).^2 + 2*(x(:,:,3,3).^2) );
    v_norm = cat(4,cat(3,norm,norm,norm),cat(3,norm,norm,norm),cat(3,norm,norm,norm));
else
    norm = sqrt ( x(:,:,1).^2 + x(:,:,2).^2 + 2*(x(:,:,3).^2) );
    v_norm = cat(3,norm,norm,norm);
end

end